Unfortunately, this feature is not supported on mobile devices. For the best experience, please use a computer.

project44 REST API (4.0.0)

Version 4.0.0 of project44's API. If you're not familiar with project44, we recommend checking out our guides first: https://developers.project44.com/guides/shippers and https://developers.project44.com/guides/carriers.

Download OpenAPI description
Languages
Servers
NA - Endpoint for project44 tenants created in the NA region
https://na12.api.project44.com/
EU - Endpoint for project44 tenants created in the EU region
https://eu12.api.project44.com/
Sandbox - Endpoint for project44 tenants created in the sandbox environment
https://na12.api.sandbox.p-44.com/

OAuth 2.0: Client Applications

API used for registering and managing OAuth 2.0 client applications. See the "Authentication" section above for more information. To authorize API requests to project44 for an API integration, first your client application must be registered with project44, which will issue your application a client id and secret. These credentials can then be used to generate bearer tokens, which can be included on all other API requests to authorize your client application. The client application is authorized through the project44 user management UI as a machine user with username "app-{client_id}@client-applications.project44.com".

An admin user (with Movement user role "Customer Admin") must use HTTP Basic Authentication with this API to manage client applications. Basic Authentication is deprecated for all other APIs, besides token generation, in favor of passing the access token generated via OAuth 2.0.

Operations

OAuth 2.0: Token Generation

API for OAuth 2.0 token generation. See the "Authentication" section above for more information. Once your client application is registered, you can use the token generation endpoint to authenticate with your application's client id and secret in exchange for a bearer token to be included on all other API requests to authenticate as that client application. The client application is authorized through the project44 user management UI as a machine user with username "app-{client_id}@client-applications.project44.com".

To generate an access token, you may authenticate your client application by providing its client id and secret either in the body of the request or in the form of HTTP Basic Authentication (but you may not use both ways in the same request).

Operations

Grant access token.

Request

Authenticate with your client application's credentials (id and secret) to generate a new project44 access token. The resulting access token can be used as a bearer token to access your project44 account and data via project44's other APIs, while acting as that client application.

You may authenticate your client application either by passing the id and secret via HTTP Basic Authentication (via the "Authorization" HTTP header) or via the client_id and client_secret fields in the POST request body with no "Authorization" header included. You may not use both approaches to authenticate the same request.

The POST request body must contain the request fields as URL-encoded parameters (a URL-encoded form) and must have the "Content-Type" HTTP header set to "application/x-www-form-urlencoded".

Required Fields

  • client_id
  • client_secret
  • grant_type
Bodyapplication/x-www-form-urlencoded
client_idstring

The id of the client application, generated and assigned by project44 via the OAuth 2.0 client applications APIs.

client_secretstring

The secret part of the client application's credentials, generated and assigned by project44 via the OAuth 2.0 client applications APIs.

grant_typestring

The OAuth 2.0 authorization grant type, or flow, to be used by the client application. project44 supports only the "client_credentials" grant type and does not currently support grant types involving end user consent.

Value"client_credentials"
curl -i -X POST \
  -u <username>:<password> \
  https://na12.api.project44.com/api/v4/oauth2/token \
  -H 'Content-Type: application/x-www-form-urlencoded' \
  -d client_id=string \
  -d client_secret=string \
  -d grant_type=client_credentials

Responses

OK

Bodyapplication/json
access_tokenstring

The project44 access token, which can be passed as a bearer token to all other project44 endpoints to have your client application's requests authorized. Pass the "Authorization" HTTP header to other endpoints in this form: "Authorization: Bearer {access_token}". Your client application can be granted roles and permissions via the project44 user management UI under user "app-{client_id}@client-applications.project44.com".

expires_ininteger(int64)

The time in seconds for which the access token will be valid before expiring. Tokens currently last approximately 12 hours, but this is subject to change by project44 in the future. Tokens should be reused by your application to the fullest extent possible for performance and security reasons by storing the token in a secure cache. Instead of using this expiration time to know when to generate a new access token, simply make requests with the token until project44 responds with a "401 Unauthorized" HTTP status code, at which point your application should generate and cache a new one.

token_typestring

The type of access token returned. This will always be type "BEARER".

Value"BEARER"
Response
application/json
{ "access_token": "string", "expires_in": 0, "token_type": "BEARER" }

Shipment: Tracking

...

Operations

Filter Suggestions

...

Operations

Shipment Attributes

...

Operations

Shipment: Loads

...

Operations

Order Visibility

...

Operations

LTL: Quotes

...

Operations

LTL: Dispatch

...

Operations

LTL: Image Retrieval

...

Operations

LTL: Electronic BOL

API used for creating Electronic BOL

Operations

VLTL: Quotes

...

Operations

VLTL: Dispatch

...

Operations

TL: Available Vehicles

...

Operations

TL: Connected Capacity

...

Operations

Asset Tracking

...

Operations

Multi-Modal: Image Retrieval

...

Operations

Multi-Modal: Rating

API used for multi-modal Rating.

Operations

Multi-Modal: Booking

API used for multi-modal Booking.

Operations

Multi-Modal: Packaging

API used for managing packages for shipment planning.

Operations

Multi-Modal: Document

...

Operations

Webhook

...

Operations

Shipment Webhook Data

Operations to describe the payload expected from project44 when integrated with a webhook for shipments.

Operations

Inventory Order and Load Webhook Data

Operations to describe the payload expected from project44 when integrated with a webhook for orders and loads.

Operations

Capacity Provider Metadata

...

Operations

Capacity Provider Contact Management

...

Operations

Capacity Provider Account Management

...

Operations

Capacity Provider Account Group Management

...

Operations

LTL: Push Tracking

...

Operations

LTL: Push Imaging

...

Operations

TL: Capacity Provider Push

...

Operations

Parcel: Push Tracking

...

Operations

Universal Push: Truckload

...

Operations

Push Updates

...

Operations

Analytics: Port Intelligence

...

Operations

Stop Location Management

...

Operations

Postal Address Validation

...

Operations

Appointments

Create, reschedule, cancel, fetch appointments in Yard Management Systems(YMS)

Operations

Capacity

Get capacity for a YMS site within the specified time range

Operations

Milestones

Update yard milestones for a shipment

Operations

Reason Codes

Retrieve all reason codes for the specified YMS site

Operations

Site Codes

Retrieve all sites for the specified YMS tenant

Operations

Slots

Get available slots for a shipment in Yard Management Systems(YMS)

Operations

Invitations

...

Operations

Ocean: Point-to-Point Schedules

...

Operations

LTL: Tracking

...

Operations

TL: Tracking

...

Operations

TL: Webhook

...

Operations

Parcel: Tracking

...

Operations

Parcel: Webhook

...

Operations

Rail: Tracking

...

Operations

Ocean: Tracking

...

Operations